﻿using System.Net.Mime;
using System.Text;
using System.Web;
using System.Web.Mvc;
using Kreta.BusinessLogic.Helpers;
using Kreta.BusinessLogic.Security;
using Kreta.Resources;
using Kreta.Web.Areas.HRModul.Logic;
using Kreta.Web.Areas.HRModul.Models;
using Kreta.Web.Helpers;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.HRModul.Controllers
{
    [MvcRoleClaimsAuthorize(true)]
    [MvcRolePackageAuthorize(KretaClaimPackages.TavolletIgenylo.ClaimValue)]
    //[MvcFeatureMaintenance(Core.Constants.FeatureName.HRModul)]
    //[MvcFeatureAuthorize(Core.Constants.FeatureName.HRModul)]
    public class TavolletListaController : Controller
    {
        public ActionResult Index()
        {
            if (ClaimData.IsAdministrator || new HRModulHelper(ConnectionTypeExtensions.GetActiveSessionConnectionType()).IsHrKezelo() || new TavolletjelentoLogic().HasSZTSZKOD(ClaimData.FelhasznaloId))
            {
                var model = new TavolletListaLogic().GetTavolletListaSearchModel();
                return View("Index", model);
            }

            return View("~/Areas/HRModul/Views/Tavolletjelento/IndexError.cshtml");
        }

        [HttpPost]
        [MvcValidateAjaxAntiForgeryToken]
        public ActionResult Export(TavolletListaSearchModel model)
        {
            var helper = new HRModulHelper(ConnectionTypeExtensions.GetSessionConnectionType());
            var alkalmazottHelper = new AlkalmazottHelper(ConnectionTypeExtensions.GetSessionConnectionType());
            var (kozpontiResult, sztszAzonositok) = new TavolletListaLogic().GetTavolletBefogadottLista(model, helper, alkalmazottHelper);

            using (var ms = helper.GetTavolletListaExport(kozpontiResult, sztszAzonositok, alkalmazottHelper))
            {
                return new FileContentResult(ms.ToArray(), MediaTypeNames.Application.Octet)
                {
                    FileDownloadName = HttpUtility.UrlEncode(HRModulResource.SzamfejtettTavolletekExportFileName, Encoding.UTF8),
                };
            }
        }
    }
}
